.nolist
include	\masm32\include\masm32rt.inc
include	Gfa2Masm.inc
includelib	Gfa2Masm.lib

FindInFileX PROTO:DWORD, :DWORD, :DWORD, :DWORD, :DWORD

FindString MACRO pMain:REQ, Sub$:REQ, sMode:=<0>, sPos:=<1>, inFile$, inFileEnd$
LOCAL SubEnd$
  ifnb <inFile$>
	ifb <inFileEnd$>						;; default: read a line
		SubEnd$ equ addr CrLf_txt
	else
		SubEnd$ equ reparg_offset(inFileEnd$)
	endif
	;; FindInFile proc StartPos:DWORD, Path$:DWORD, Find$:DWORD, FindEnd$:DWORD, Mode:DWORD
	invoke FindInFileX, sPos, reparg_offset(inFile$), reparg_offset(Sub$), SubEnd$, sMode
  endif
ENDM


EXIST MACRO fname:REQ, DiscardHandle:=<1>	; .if EXIST("MyFile.*,0) leaves handle
 ; mov wfd.dwFileAttributes, 0 ;FILE_ATTRIBUTE_NORMAL=80h
 invoke FindFirstFile, reparg_offset(fname), addr wfd
 .if eax==INVALID_HANDLE_VALUE
	xor eax, eax
 .else
	if DiscardHandle
		invoke FindClose, eax
		xor eax, eax
	endif
 .endif
 mov FifHandle, eax	;; file search handle
 EXITM <eax>
ENDM

FSNEXT MACRO dummy
 ; mov wfd.dwFileAttributes, 0 ;FILE_ATTRIBUTE_NORMAL=80h
 invoke FindNextFile, FifHandle, addr wfd
; .if eax==ERROR_NO_MORE_FILES
;	pushad
;	MsgBox str$(eax), chr$("NO_MORE_FILES"), MB_OK
;	popad
;  .endif
 .if eax==0
	invoke FindClose, FifHandle
	xor eax, eax
	mov FifHandle, eax
  .endif
  EXITM <eax>
ENDM

.data?
FifHandle	dd ?
FifCtFiles	dd ?
LastFoundFile	dd MAX_PATH/4 dup (?)

BufFiles	dd MAX_PATH/4 dup (?)
BufStart	dd 20 dup (?)
BufEnd	dd 20 dup (?)

.code
FS$	dd BufStart		; Find_in_file
FSD$	dd BufEnd		; Find_delimiter
FileName$	dd BufFiles		; txFileName

AppTitle	db "Testing FindString:", 0
Find_in_file	db "Warning", 0		; the string we are looking for
; Find_in_file	db "GetTextEx", 0		; the string we are looking for
; Find_in_file	db " struct", 0		; the string we are looking for
; Find_delimiter	db "ends", 0		; show it including this delimiting text (default: CrLf$)
txFileName	db "\masm32\include\*.inc", 0		; the files we want to examine
txComment		db "Case-insensitive search in", 0

start:
	push esi

	.if 0
		FindString 0, FS$	; dummy call to the macro helps - comment out to see the difference
	.endif

	invoke GetCL, 1, FileName$
	.if eax!=1
		invoke lstrcpy, FileName$, addr txFileName
	.endif

	invoke GetCL, 2, FS$
	.if eax!=1
		invoke lstrcpy, FS$, addr Find_in_file
	.endif

	invoke GetCL, 3, FSD$
	.if eax!=1
		invoke lstrcpy, FSD$, CrLf$	; seems not to work yet
	.endif

	invoke GetTickCount  	; start timer
	push eax

	; Syntax: FindString pMain, Sub$  [, IgnoreCase]  [, sPos]  [, inFile$]  [, inFileEnd$]

	FindString 0, FS$, 1, 1, FileName$	; , FSD$		; no inFileEnd$: take CrLf

	invoke GetTickCount  	; end timer
	mov esi, eax
	pop eax
	sub esi, eax			; time in ms

;	OPT_Susy	Console
	print chr$('Usage: fif \masm32\include\*.inc "RECT struct" ends')
	print chr$(13, 10, 10)
	invoke StdOut, CAT$("We found '", FS$, "' in ",str$(FifCtFiles)," files",chr$(59), " example:",CrLf$, FifRet$, CrLf$, CrLf$,addr txComment, CrLf$, FileName$, CrLf$, "took only ", str$(esi), " ms")

	free$ FileBuf$			; cleanup
	pop esi
	exit

FindInFileX proc StartPos:DWORD, Path$:DWORD, Find$:DWORD, FindEnd$:DWORD, Mode:DWORD
LOCAL fLen:DWORD, FeCrLf$:DWORD, FifRetCt:DWORD
LOCAL FifPosEcx:DWORD, FifPosEax:DWORD, FifEtc:DWORD
LOCAL LocPath[MAX_PATH]:BYTE
  .if EXIST(Path$, 0)	; 0=don't close FifHandle
	xor eax, eax
	mov FifCtFiles, eax
	mov FifRetCt, eax
	mov FifEtc, eax
	push esi
	.While 1
		lea esi, LocPath				; behind the loop start - we need esi below
		invoke lstrcpy, esi, Path$
		mov ecx, len(Path$)
		add ecx, esi
		.While ecx>esi
			mov al, [ecx-1]
			.break .if al=="\"
			dec ecx
		.Endw
		invoke lstrcpy, ecx, addr wfd.cFileName
		invoke lstrcmp, esi, LastPath$
		.if eax	;; file name differs from last one, so load it
			invoke lstrcpy, LastPath$, esi	; Path$
			free$ FileBuf$
			OPEN "I", #1, esi
			mov fLen, LOF(#1)
			mov FileBuf$, alloc$(fLen)
			INPUT #1, FileBuf$, fLen
			CLOSE
		.endif
		invoke InstrCi, StartPos, FileBuf$, Find$, Mode
		.if eax
			inc FifCtFiles							; count the files
			mov FifPosEcx, ecx						; ecx=pos in file
			mov FifPosEax, eax						; startpos first string
			invoke InstrCi, FifPosEcx, FileBuf$, FindEnd$, Mode	; continue search
			.if eax
				.if FifRetCt==0
					mov esi, eax
					add esi, len(FindEnd$)
					sub esi, FifPosEax			; endpos - startpos = ct
					inc esi
					.if esi>700
						mov esi, 700			; see below, limits of MsgBox
					.endif
					invoke lstrcpyn, FifRet$, FifPosEax, esi	; no zero terminator...
					xor eax, eax
					mov edx, FifRet$
					mov [edx+esi-1], al
					invoke lstrcat, FifRet$, CrLf$
				.endif
				mov esi, FifRet$
				mov FifRetCt, len(esi)		; approx. # of bytes copied
				.if FifRetCt<800		; limit is 1600, but MsgBox cannot take more than ca. 900
					invoke lstrcat, esi, chr$(13, 10, "in ")
					invoke lstrcat, esi, addr wfd.cFileName
					invoke lstrcat, esi, chr$(" at pos ")
					invoke lstrcat, esi, str$(FifPosEcx)
					invoke lstrcat, esi, chr$(" of ")
					invoke lstrcat, esi, str$(fLen)
					invoke lstrcat, esi, chr$(" bytes")
				.elseif FifEtc==0
					inc FifEtc
					invoke lstrcat, esi, chr$(13, 10, "... etc.")
				.endif
			.endif
			mov ecx, FifPosEcx		; ecx=pos in file for last occurrence of string
  		.endif
		.break .if FSNEXT()==0
	.Endw
	pop esi
	mov eax, FifRetCt
	dec eax				; eax=len of found line
	mov edx, FifRet$	; edx=pointer to buffer containing the found text
	mov ecx, FifPosEcx
  .else
	invoke MessageBox, NULL, Path$, chr$("Sorry, this file does not exist:"), MB_OK
  .endif
  ret
FindInFileX endp

end start

OPT_Linker	polink	; Pelle's linker makes short exes
OPT_DelTmp	1
OPT_WAIT	1	; 1 to see the output of the batch file
OPT_Tmp2Asm	1	; 1 to create (and overwrite without prompting!!) a plain text LibDemo.asm
